// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "Terminal.h", created on 06/07/99.
 * descr : terminal class
 */
// ----------------------------------------------------------------------------------

#ifndef TerminalH
#define TerminalH

#include "TextScr.h"
#include "Term.h"

// ----------------------------------------------------------------------------------
class Terminal : public Term {
    TextScreenEmu con;
    Block <XStr> history;
    int historyIndex;
    XStr user,prompt;
    bool logged;
    bool inMsgLoop;
    bool setuser(XStr);
    void messageLoop();
    void loginB()  { logged=true;  }
    void logoutB() { logged=false; }
    bool Terminal::printLine(XStr line, int & n);
    void Terminal::printStream(istream & s);
    char buffer[1024];

    // 'set' stuff
    enum svType { svError, svInt, svBool, svFloat };
    struct setVar {
      char * name;
      svType type;
      void * data;
      void (*callBack)(void * data, void * newData);
      char * range; // only for float/int
    };
    setVar * vars;
    void setVariable(istream & s);

    // alias stuff
    class Alias {
      public:
        XStr name,command;
        bool operator == (const Alias & r) const
          { return downcase(name)==downcase(r.name); }
        Alias(XStr n = "", XStr c = "") : name(n), command(c) { }
    };
    Block <Alias> aliases;
    int aliasCount;
    bool executeB(XStr);
    XStr atURL(XStr url);
    XStr formatHtml(XStr what);
    void help(XStr topic);
  public:
    Terminal();
    virtual ~Terminal();
    // ok, i know, that virtual funcs can't be inline, but ... i'm too lazy to change that
    virtual void init();
    virtual void login() { loginB(); messageLoop(); }
    virtual void add(XStr line);
    virtual void executeFile(XStr);
    virtual void print(XStr text);
    virtual void execute(XStr a) { executeB(a); }
    virtual XStr className() { return "Terminal"; }
    virtual void handleEvent(Event * e);
};
// ----------------------------------------------------------------------------------

#endif // TerminalH



