// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "TextScr.h", created on 06/07/99.
 * descr : textscr class - gfx stuff for termial class (see Terminal.h)
 * (renamed from "Console.h")
 */
// ----------------------------------------------------------------------------------

#ifndef TextScrH
#define TextScrH

#ifndef GfxH
#  include "Gfx.h"
#endif

// ----------------------------------------------------------------------------------
class TextScreenEmu {
    bool ready;
    int dy;
    int textColor; float colorDiff;
    Font font;  
    void dumpLine(int y);
    char convert(char);
    void drawLine(int y);
    void TextScreenEmu::slide(bool down);
  public:
    char * lineBuf;
    char * buffer;
    int w,h;
    Bitmap bgd;
    Bmp backup;
    TextScreenEmu();
    ~TextScreenEmu();
    void init();
    void scroll();
    void add(XStr line);
    void setLast(XStr line);
    bool loadFont(XStr name);
    void login();
    void logout();
    void drawAll();
    void setTextColor(int color, float d);
    void clear() { if(buffer) { memset(buffer,' ',w*h); drawAll(); } }
};
// ----------------------------------------------------------------------------------

#endif // TextScrH



